; Macros and variables to create MASM executables with minimal import section

include		\masm32\include\masm32.inc
includelib		\masm32\lib\masm32.lib

.data
counter1		dd 0
_getprocaddr	db "GetProcAddress",0
_loadlibrary	db "LoadLibraryA",0
_freelibrary	db "FreeLibrary",0

.data?
NameNumb1	dd ?
tempvar1		dd ?
gpa		dd ?
freelib		dd ?


LOAD_LIBS MACRO

LOCAL loop1,loop2,nogpa,offset1,_start1,_start2,_start3,_start4

	mov	ecx, [esp+9*4]    
loop1:
	dec	ecx
	movzx	edx, WORD PTR [ecx+03Ch]   
	cmp	ecx, [ecx+edx+034h]
	jnz	loop1
	mov	hkernel32,ecx	; This trick to get the handle of kernel32.dll
	push	esi		; can be found at win32asm forum
	push	edi
	push	ebx     
	mov	edi,ecx
	assume	edi:ptr IMAGE_DOS_HEADER
	add	edi,[edi].e_lfanew
	assume	edi:ptr IMAGE_NT_HEADERS
	mov	edi,[edi].OptionalHeader.DataDirectory.VirtualAddress
	add	edi,ecx
	mov	tempvar1,edi
	assume	edi:ptr IMAGE_EXPORT_DIRECTORY
	mov	eax,[edi].NumberOfNames
	mov	NameNumb1,eax
	mov	esi,[edi].AddressOfNames
	add	esi,hkernel32
	push	esi
	pop	ebx
	.WHILE	NameNumb1>0
		mov	edi,[esi]
		add	edi,hkernel32
		invoke	szCmp,edi,ADDR _getprocaddr
		or	eax,eax
		jz	nogpa
		mov	edi,tempvar1
		mov	esi,[edi].AddressOfNameOrdinals          
		mov	ecx,counter1
		inc	ecx
		shl	ecx,1
		add	esi,ecx 
		add	esi,hkernel32
		xor	eax,eax
		mov	ax,word ptr [esi]
		mov	esi,[edi].AddressOfFunctions
		add	esi,hkernel32
		dec	eax
		shl	eax,2
		add	esi,eax	
		mov	edi,[esi]
		add	edi,hkernel32
		mov	gpa,edi
		mov	eax,hkernel32
		mov	hkernel32,eax
		.BREAK
nogpa:		
		inc	counter1
		dec	NameNumb1
		add	esi,4
	.ENDW

	invoke2	gpa,hkernel32,ADDR _freelibrary
	mov	freelib,eax
	invoke2	gpa,hkernel32,ADDR _loadlibrary
	mov	ebx,eax
	mov	esi,OFFSET loadDLL
	mov	edi,OFFSET hModules
loop2:
	mov	al,byte ptr [esi]
	or	al,al
	jz	offset1     
	invoke2	ebx,esi
	mov	DWORD PTR [edi],eax
	add	edi,4
	invoke2	StrLen,esi
	lea	esi,[esi+eax+1]
	jmp	loop2
offset1:
	mov edi,OFFSET impfuncs
	mov esi,OFFSET ProcAddr
_start1:
	mov	eax,DWORD PTR [edi]
	or	eax,eax
	jz	_start4
	mov	ecx,[eax]
	mov	ebx,ecx
	add	edi,4
_start2:
	mov	al,byte ptr [edi]
	or	al,al
	jnz	_start3
	inc	edi
	jmp	_start1
_start3:
	invoke2	gpa,ebx,edi
	mov	[esi],eax
	add	esi,4
	invoke2	StrLen,edi
	lea	edi,[edi+eax+1]
	jmp	_start2

_start4:
	pop	ebx
	pop	edi
	pop	esi
ENDM

invoke2 MACRO funcname:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20
local pos

    FOR arg,<p20,p19,p18,p17,p16,p15,p14,p13,p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>

        IFNB <arg>
             pos=@InStr(1,arg,<ADDR>) OR @InStr(1,arg,<addr>) OR @InStr(1,arg,<Addr>)

             IF pos

                IF (OPATTR(@SubStr(arg,%pos+5))) EQ 98
                        lea eax,@SubStr(<arg>,%pos+5)
                        push eax
                ELSE
                        push OFFSET @SubStr(<arg>,%pos+5)
                ENDIF

             ELSE
                        push arg
             ENDIF
        ENDIF
    ENDM
call funcname
ENDM

cinvoke MACRO funcname:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20

local pos
paramcounter=0

    FOR arg,<p20,p19,p18,p17,p16,p15,p14,p13,p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>

        IFNB <arg>
	paramcounter=paramcounter+4             
             pos=@InStr(1,arg,<ADDR>) OR @InStr(1,arg,<addr>) OR @InStr(1,arg,<Addr>)

             IF pos

                IF (OPATTR(@SubStr(arg,%pos+5))) EQ 98
                        lea eax,@SubStr(<arg>,%pos+5)
                        push eax
                ELSE
                        push OFFSET @SubStr(<arg>,%pos+5)
                ENDIF

             ELSE
                        push arg
             ENDIF
        ENDIF
    ENDM

call funcname

IF paramcounter NE 0
	add esp,paramcounter
ENDIF

ENDM


Invoke2	EQU <invoke2>

EXIT_APPLICATION MACRO var1
	Invoke	ExitProcess,var1
ENDM

_include MACRO var1
LOCAL temp
% include @SubStr(var1,2,@SizeStr(var1)-2)
ENDM

FREE_LIBS MACRO
LOCAL loop3
	push	eax
	push	esi
	push	edi
	mov	edi,NumbOfModules
	mov	esi,OFFSET hModules
loop3:
	invoke2	freelib,DWORD PTR [esi]
	add	esi,4
	dec	edi
	jnz	loop3
	pop	edi
	pop	esi
	pop	eax
ENDM